<cfcomponent displayname="xboxGateway" output="false">
	<cffunction name="init" access="public" output="false" returntype="blank.com.xboxGateway">
		<cfargument name="transfer" type="transfer.com.Transfer" required="true" />
		<cfset variables.transfer = arguments.transfer />
		<cfreturn this />
	</cffunction>
	
	<cffunction name="getByAttributesQuery" access="public" output="false" returntype="query">
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="type" type="String" required="false" />
		<cfargument name="storage" type="Numeric" required="false" />
		<cfargument name="orderby" type="string" required="false" default="xbox.consoleID" />
		
		<cfset var qList = "" />
		<cfset var tQuery = "" />	
		<cfsavecontent variable="qList">
		<cfoutput>
			FROM		xbox.xbox AS xbox
			WHERE		xbox.consoleID IS NOT NULL
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			AND		xbox.consoleID = :consoleID
		</cfif><cfif structKeyExists(arguments,"type") and len(arguments.type)>
			AND		xbox.type = :type
		</cfif><cfif structKeyExists(arguments,"storage") and len(arguments.storage)>
			AND		xbox.storage = :storage
		</cfif>
		<cfif structKeyExists(arguments, "orderby") and len(arguments.orderBy)>
			ORDER BY #arguments.orderby#
		</cfif>
		</cfoutput>
		</cfsavecontent>
		<cfset tQuery = variables.transfer.createQuery(qList) />
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			<cfset tQuery.setParam("consoleID",arguments.consoleID) />
		</cfif>
		<cfif structKeyExists(arguments,"type") and len(arguments.type)>
			<cfset tQuery.setParam("type",arguments.type) />
		</cfif>
		<cfif structKeyExists(arguments,"storage") and len(arguments.storage)>
			<cfset tQuery.setParam("storage",arguments.storage) />
		</cfif>
		
		<cfreturn variables.transfer.listByQuery(tQuery) />
	</cffunction>

	<cffunction name="getByAttributes" access="public" output="false" returntype="array">
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="type" type="String" required="false" />
		<cfargument name="storage" type="Numeric" required="false" />
		<cfargument name="orderby" type="string" required="false" />
		
		<cfset var qList = getByAttributesQuery(argumentCollection=arguments) />		
		<cfset var arrObjects = arrayNew(1) />
		<cfset var tmpObj = "" />
		<cfset var i = 0 />
		<cfloop from="1" to="#qList.recordCount#" index="i">
			<cfset tmpObj = variables.transfer.get("xbox.xbox",qList.consoleID[i]) />
			<cfset arrayAppend(arrObjects,tmpObj) />
		</cfloop>
				
		<cfreturn arrObjects />
	</cffunction>

</cfcomponent>
