<cfcomponent name="xboxService" output="false">

	<cffunction name="init" access="public" output="false" returntype="blank.com.xboxService">
		<cfargument name="transfer" type="transfer.com.Transfer" required="true" />
		<cfargument name="xboxGateway" type="blank.com.xboxGateway" required="true" />

		<cfset variables.transfer = arguments.transfer />
		<cfset variables.xboxGateway = arguments.xboxGateway />

		<cfreturn this/>
	</cffunction>

	<cffunction name="createxbox" access="public" output="false" returntype="blank.com.xbox">
		<cfargument name="consoleID" type="uuid" required="true" />
		<cfargument name="type" type="String" required="false" />
		<cfargument name="storage" type="Numeric" required="false" />
		
			
		<cfset var xbox = variables.transfer.get("xbox.xbox",arguments.consoleID) />
		<cfset xbox.setMemento(arguments) />
		<cfreturn xbox />
	</cffunction>

	<cffunction name="getxbox" access="public" output="false" returntype="any">
		<cfargument name="consoleID" type="uuid" required="true" />

		<cfreturn variables.transfer.get("xbox.xbox",arguments.consoleID) />
	</cffunction>

	<cffunction name="getxboxs" access="public" output="false" returntype="array">
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="type" type="String" required="false" />
		<cfargument name="storage" type="Numeric" required="false" />
		
		<cfreturn variables.xboxGateway.getByAttributes(argumentCollection=arguments) />
	</cffunction>

	<cffunction name="savexbox" access="public" output="false" returntype="void">
		<cfargument name="xbox" type="blank.com.xbox" required="true" />
		
		<cfset variables.transfer.save(arguments.xbox) />
	</cffunction>

	<cffunction name="deletexbox" access="public" output="false" returntype="void">
		<cfargument name="consoleID" type="uuid" required="true" />
		
		<cfset var xbox = variables.transfer.get("xbox.xbox",arguments.consoleID) />
		<cfset variables.transfer.delete(xbox) />
	</cffunction>
</cfcomponent>
