<cfcomponent displayname="game" output="false">
		<cfproperty name="gameID" type="uuid" default="" />
		<cfproperty name="gameName" type="String" default="" />
		<cfproperty name="specialEdition" type="Boolean" default="" />
		
	<!---
	PROPERTIES
	--->
	<cfset variables.instance = StructNew() />

	<!---
	INITIALIZATION / CONFIGURATION
	--->
	<cffunction name="init" access="public" returntype="csFlex.com.xbox.games.game" output="false">
		<cfargument name="gameID" type="uuid" required="false" default="#createUUID()#" />
		<cfargument name="gameName" type="string" required="false" default="" />
		<cfargument name="specialEdition" type="string" required="false" default="" />
		
		<!--- run setters --->
		<cfset setgameID(arguments.gameID) />
		<cfset setgameName(arguments.gameName) />
		<cfset setspecialEdition(arguments.specialEdition) />
		
		<cfreturn this />
 	</cffunction>

	<!---
	PUBLIC FUNCTIONS
	--->
	<cffunction name="setMemento" access="public" returntype="csFlex.com.xbox.games.game" output="false">
		<cfargument name="memento" type="struct" required="yes"/>
		<cfset variables.instance = arguments.memento />
		<cfreturn this />
	</cffunction>
	<cffunction name="getMemento" access="public" returntype="struct" output="false" >
		<cfreturn variables.instance />
	</cffunction>

	<cffunction name="validate" access="public" returntype="array" output="false">
		<cfset var errors = arrayNew(1) />
		<cfset var thisError = structNew() />
		
		<!--- gameID --->
		<cfif (NOT len(trim(getgameID())))>
			<cfset thisError.field = "gameID" />
			<cfset thisError.type = "required" />
			<cfset thisError.message = "gameID is required" />
			<cfset arrayAppend(errors,duplicate(thisError)) />
		</cfif>
		
		<!--- gameName --->
		<cfif (NOT len(trim(getgameName())))>
			<cfset thisError.field = "gameName" />
			<cfset thisError.type = "required" />
			<cfset thisError.message = "gameName is required" />
			<cfset arrayAppend(errors,duplicate(thisError)) />
		</cfif>
		
		<!--- specialEdition --->
		<cfif (NOT len(trim(getspecialEdition())))>
			<cfset thisError.field = "specialEdition" />
			<cfset thisError.type = "required" />
			<cfset thisError.message = "specialEdition is required" />
			<cfset arrayAppend(errors,duplicate(thisError)) />
		</cfif>
		
		<cfreturn errors />
	</cffunction>

	<!---
	ACCESSORS
	--->
	<cffunction name="setgameID" access="public" returntype="void" output="false">
		<cfargument name="gameID" type="uuid" required="true" />
		<cfset variables.instance.gameID = arguments.gameID />
	</cffunction>
	<cffunction name="getgameID" access="public" returntype="uuid" output="false">
		<cfreturn variables.instance.gameID />
	</cffunction>

	<cffunction name="setgameName" access="public" returntype="void" output="false">
		<cfargument name="gameName" type="string" required="true" />
		<cfset variables.instance.gameName = arguments.gameName />
	</cffunction>
	<cffunction name="getgameName" access="public" returntype="string" output="false">
		<cfreturn variables.instance.gameName />
	</cffunction>

	<cffunction name="setspecialEdition" access="public" returntype="void" output="false">
		<cfargument name="specialEdition" type="string" required="true" />
		<cfset variables.instance.specialEdition = arguments.specialEdition />
	</cffunction>
	<cffunction name="getspecialEdition" access="public" returntype="string" output="false">
		<cfreturn variables.instance.specialEdition />
	</cffunction>


	<!---
	DUMP
	--->
	<cffunction name="dump" access="public" output="true" return="void">
		<cfargument name="abort" type="boolean" default="false" />
		<cfdump var="#variables.instance#" />
		<cfif arguments.abort>
			<cfabort />
		</cfif>
	</cffunction>

</cfcomponent>
