<cfcomponent displayname="accessoryGateway" output="false">
	<cffunction name="init" access="public" output="false" returntype="tf.com.xbox.accessories.accessoryGateway">
		<cfargument name="transfer" type="transfer.com.Transfer" required="true" />
		
		<cfset variables.transfer = arguments.transfer />
		<cfreturn this />
	</cffunction>
	
	<cffunction name="getByAttributesQuery" access="public" output="false" returntype="query">
		<cfargument name="accessoryID" type="uuid" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="accessoryName" type="String" required="false" />
		<cfargument name="orderby" type="string" required="false" default="accessory.accessoryID" />
		
		<cfset var qList = "" />
		<cfset var tQuery = "" />
		<cfsavecontent variable="qList">
		<cfoutput>
			FROM	console.accessory AS accessory JOIN console.console AS console
			WHERE	accessory.accessoryID IS NOT NULL
		<cfif structKeyExists(arguments,"accessoryID") and len(arguments.accessoryID)>
			AND	accessory.accessoryID = :accessoryID
		</cfif>
		<cfif structKeyExists(arguments,"accessoryName") and len(arguments.accessoryName)>
			AND	accessory.accessoryName = :accessoryName
		</cfif>
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			AND	console.consoleID = :consoleID
		</cfif>
		<cfif structKeyExists(arguments, "orderby") and len(arguments.orderBy)>
			ORDER BY #arguments.orderby#
		</cfif>
		</cfoutput>
		</cfsavecontent>
		<cfset tQuery = variables.transfer.createQuery(qList) />
		<cfif structKeyExists(arguments,"accessoryID") and len(arguments.accessoryID)>
			<cfset tQuery.setParam("accessoryID",arguments.accessoryID) />
		</cfif>
		<cfif structKeyExists(arguments,"accessoryName") and len(arguments.accessoryName)>
			<cfset tQuery.setParam("accessoryName",arguments.accessoryName) />
		</cfif>
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			<cfset tQuery.setParam("consoleID",arguments.consoleID) />
		</cfif>
		
		<cfreturn variables.transfer.listByQuery(tQuery) />
	</cffunction>
	<cffunction name="getByAttributes" access="public" output="false" returntype="array">
		<cfargument name="accessoryID" type="uuid" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="accessoryName" type="String" required="false" />
		<cfargument name="orderby" type="string" required="false" />
		
		<cfset var qList = getByAttributesQuery(argumentCollection=arguments) />		
		<cfset var arrObjects = arrayNew(1) />
		<cfset var tmpObj = "" />
		<cfset var i = 0 />
		<cfloop from="1" to="#qList.recordCount#" index="i">
			<cfset tmpObj = variables.transfer.get("console.accessory",qList.accessoryID[i]) />
			<cfset arrayAppend(arrObjects,tmpObj) />
		</cfloop>
		
		<cfreturn arrObjects />
	</cffunction>

</cfcomponent>
