<cfcomponent name="consoleService" output="false">

	<cffunction name="init" access="public" output="false" returntype="tf.com.xbox.consoleService">
		<cfargument name="transfer" type="any" required="true" />
		<cfargument name="consoleGateway" type="tf.com.xbox.consoleGateway" required="true" />
		<cfargument name="controlGateway" type="tf.com.xbox.controls.controlGateway" required="true" />
		<cfargument name="accessoryGateway" type="tf.com.xbox.accessories.accessoryGateway" required="true" />
		<cfargument name="gameGateway" type="tf.com.xbox.games.gameGateway" required="true" />

		<cfset variables.transfer = arguments.transfer />
		<cfset variables.consoleGateway = arguments.consoleGateway />
		<cfset variables.controlGateway = arguments.controlGateway />
		<cfset variables.accessoryGateway = arguments.accessoryGateway />
		<cfset variables.gameGateway = arguments.gameGateway />

		<cfreturn this/>
	</cffunction>

<!--- console --->
	<cffunction name="createConsole" access="public" output="false" returntype="console">
		<cfargument name="consoleID" type="String" required="true" />
		<cfargument name="type" type="String" required="false" />
		<cfargument name="storage" type="Numeric" required="false" />
		
		<cfset var console = variables.transfer.get("console.console",arguments.consoleID) />
		<cfset console.setMemento(arguments) />
		<cfreturn console />
	</cffunction>
	<cffunction name="getConsole" access="public" output="false" returntype="console">
		<cfargument name="consoleID" type="String" required="true" />
		
		<cfset var console = variables.transfer.get("console.console",arguments.consoleID) />
		<cfreturn console />
	</cffunction>
	<cffunction name="getConsoles" access="public" output="false" returntype="array">
		<cfargument name="consoleID" type="String" required="false" />
		<cfargument name="type" type="String" required="false" />
		<cfargument name="storage" type="Numeric" required="false" />
		
		<cfreturn variables.consoleGateway.getByAttributes(argumentCollection=arguments) />
	</cffunction>
	<cffunction name="saveConsole" access="public" output="false" returntype="void">
		<cfargument name="console" type="tf.com.xbox.console" required="true" />
		
		<cfset variables.transfer.save(arguments.console) />
	</cffunction>
	<cffunction name="deleteConsole" access="public" output="false" returntype="boolean">
		<cfargument name="consoleID" type="String" required="true" />
		
		<cfset var console = createConsole(argumentCollection=arguments) />
		<cfset variables.transfer.delete(console) />
	</cffunction>

<!--- control --->
	<cffunction name="createControl" access="public" output="false" returntype="tf.com.xbox.controls.control">
		<cfargument name="controlID" type="uuid" required="true" />
		<cfargument name="wireless" type="Boolean" required="false" />
		<cfargument name="headset" type="Boolean" required="false" />
		
		<cfset var control = variables.transfer.get("console.control",arguments.controlID) />
		<cfset control.setMemento(arguments) />
		<cfreturn control />
	</cffunction>
	<cffunction name="getControl" access="public" output="false" returntype="control">
		<cfargument name="controlID" type="uuid" required="true" />
		
		<cfreturn variables.transfer.get("console.control",arguments.controlID) />
	</cffunction>
	<cffunction name="getControls" access="public" output="false" returntype="array">
		<cfargument name="controlID" type="uuid" required="false" />
		<cfargument name="wireless" type="Boolean" required="false" />
		<cfargument name="headset" type="Boolean" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		
		<cfreturn variables.controlGateway.getByAttributes(argumentCollection=arguments) />
	</cffunction>
	<cffunction name="saveControl" access="public" output="false" returntype="void">
		<cfargument name="control" type="tf.com.xbox.controls.control" required="true" />
		
		<cfset variables.transfer.save(arguments.control) />
	</cffunction>
	<cffunction name="deleteControl" access="public" output="false" returntype="void">
		<cfargument name="controlID" type="String" required="true" />
		
		<cfset var control = createControl(argumentCollection=arguments) />
		<cfset variables.transfer.delete(control) />
	</cffunction>
	
<!--- game --->
	<cffunction name="createGame" access="public" output="false" returntype="tf.com.xbox.games.game">
		<cfargument name="gameID" type="uuid" required="true" />
		<cfargument name="gameName" type="String" required="false" />
		<cfargument name="specialEdition" type="Boolean" required="false" />
		
		<cfset var game = variables.transfer.get("console.game",arguments.gameID) />
		<cfset game.setMemento(arguments) />
		<cfreturn game />
	</cffunction>
	<cffunction name="getGame" access="public" output="false" returntype="tf.com.xbox.games.game">
		<cfargument name="gameID" type="uuid" required="true" />
		
		<cfreturn variables.transfer.get("console.game",arguments.gameID) />
	</cffunction>
	<cffunction name="getGames" access="public" output="false" returntype="array">
		<cfargument name="gameID" type="uuid" required="false" />
		<cfargument name="gameName" type="String" required="false" />
		<cfargument name="specialEdition" type="Boolean" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		
		<cfreturn variables.gameGateway.getByAttributes(argumentCollection=arguments) />
	</cffunction>
	<cffunction name="saveGame" access="public" output="false" returntype="void">
		<cfargument name="game" type="tf.com.xbox.games.game" required="true" />

		<cfset variables.transfer.save(arguments.game) />
	</cffunction>
	<cffunction name="deleteGame" access="public" output="false" returntype="boolean">
		<cfargument name="gameID" type="uuid" required="true" />
		
		<cfset var game = createGame(argumentCollection=arguments) />
		<cfset variables.transfer.delete(game) />
	</cffunction>
	
<!--- accessory --->
	<cffunction name="createAccessory" access="public" output="false" returntype="tf.com.xbox.accessories.accessory">
		<cfargument name="accessoryID" type="uuid" required="true" />
		<cfargument name="accessoryName" type="String" required="false" />
		
		<cfset var accessory = variables.transfer.get("console.accessory",arguments.accessoryID) />
		<cfset accessory.setMemento(arguments) />
		<cfreturn accessory />
	</cffunction>
	<cffunction name="getAccessory" access="public" output="false" returntype="tf.com.xbox.accessories.accessory">
		<cfargument name="accessoryID" type="uuid" required="true" />
		
		<cfreturn variables.transfer.get("console.accessory",arguments.accessoryID) />
	</cffunction>
	<cffunction name="getAccessories" access="public" output="false" returntype="array">
		<cfargument name="accessoryID" type="uuid" required="false" />
		<cfargument name="accessoryName" type="String" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		
		<cfreturn variables.accessoryGateway.getByAttributes(argumentCollection=arguments) />
	</cffunction>
	<cffunction name="saveAccessory" access="public" output="false" returntype="void">
		<cfargument name="accessory" type="tf.com.xbox.accessories.accessory" required="true" />

		<cfset variables.transfer.save(accessory) />
	</cffunction>
	<cffunction name="deleteaccessory" access="public" output="false" returntype="void">
		<cfargument name="accessoryID" type="uuid" required="true" />
		
		<cfset var accessory = createAccessory(argumentCollection=arguments) />
		<cfreturn variables.transfer.delete(accessory) />
	</cffunction>
</cfcomponent>
