<cfcomponent displayname="controlGateway" output="false">
	<cffunction name="init" access="public" output="false" returntype="tf.com.xbox.controls.controlGateway">
		<cfargument name="transfer" type="any" required="true" />
		
		<cfset variables.transfer = arguments.transfer />
		<cfreturn this />
	</cffunction>
	
	<cffunction name="getByAttributesQuery" access="public" output="false" returntype="query">
		<cfargument name="controlID" type="uuid" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="wireless" type="Boolean" required="false" />
		<cfargument name="headset" type="Boolean" required="false" />
		<cfargument name="orderby" type="string" required="false" default="control.controlID" />
		
		<cfset var qList = "" />
		<cfset var tQuery = "" />
		<cfsavecontent variable="qList">
		<cfoutput>
			FROM	console.control AS control JOIN console.console AS console
			WHERE	control.controlID IS NOT NULL
		<cfif structKeyExists(arguments,"controlID") and len(arguments.controlID)>
			AND	control.controlID = :controlID
		</cfif>
		<cfif structKeyExists(arguments,"wireless") and len(arguments.wireless)>
			AND	control.wireless = :wireless
		</cfif>
		<cfif structKeyExists(arguments,"headset") and len(arguments.headset)>
			AND	control.headset = :headset
		</cfif>
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			AND	console.consoleID = :consoleID
		</cfif>
		<cfif structKeyExists(arguments, "orderby") and len(arguments.orderBy)>
			ORDER BY #arguments.orderby#
		</cfif>
		</cfoutput>
		</cfsavecontent>
		<cfset tQuery = variables.transfer.createQuery(qList) />
		<cfif structKeyExists(arguments,"controlID") and len(arguments.controlID)>
			<cfset tQuery.setParam("controlID",arguments.controlID) />
		</cfif>
		<cfif structKeyExists(arguments,"wireless") and len(arguments.wireless)>
			<cfset tQuery.setParam("wireless",arguments.wireless) />
		</cfif>
		<cfif structKeyExists(arguments,"headset") and len(arguments.headset)>
			<cfset tQuery.setParam("headset",arguments.headset) />
		</cfif>
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			<cfset tQuery.setParam("consoleID",arguments.consoleID) />
		</cfif>
		
		<cfreturn variables.transfer.listByQuery(tQuery) />
	</cffunction>
	<cffunction name="getByAttributes" access="public" output="false" returntype="array">
		<cfargument name="controlID" type="uuid" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="wireless" type="Boolean" required="false" />
		<cfargument name="headset" type="Boolean" required="false" />
		<cfargument name="orderby" type="string" required="false" />
		
		<cfset var qList = getByAttributesQuery(argumentCollection=arguments) />		
		<cfset var arrObjects = arrayNew(1) />
		<cfset var tmpObj = "" />
		<cfset var i = 0 />
		<cfloop from="1" to="#qList.recordCount#" index="i">
			<cfset tmpObj = variables.transfer.get("console.control",qList.controlID[i]) />
			<cfset arrayAppend(arrObjects,tmpObj) />
		</cfloop>
		
		<cfreturn arrObjects />
	</cffunction>


</cfcomponent>
