<cfcomponent displayname="gameGateway" output="false">
	<cffunction name="init" access="public" output="false" returntype="tf.com.xbox.games.gameGateway">
		<cfargument name="transfer" type="any" required="true" />
		
		<cfset variables.transfer = arguments.transfer />
		<cfreturn this />
	</cffunction>
	
	<cffunction name="getByAttributesQuery" access="public" output="false" returntype="query">
		<cfargument name="gameID" type="uuid" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="gameName" type="String" required="false" />
		<cfargument name="specialEdition" type="Boolean" required="false" />
		<cfargument name="orderby" type="string" required="false" default="game.gameID" />
		
		<cfset var qList = "" />
		<cfset var tQuery = "" />
		<cfsavecontent variable="qList">
		<cfoutput>
			FROM	console.game AS game JOIN console.console AS console
			WHERE	game.gameID IS NOT NULL
		<cfif structKeyExists(arguments,"gameID") and len(arguments.gameID)>
			AND	game.gameID = :gameID
		</cfif>
		<cfif structKeyExists(arguments,"gameName") and len(arguments.gameName)>
			AND	game.gameName = :gameName
		</cfif>
		<cfif structKeyExists(arguments,"specialEdition") and len(arguments.specialEdition)>
			AND	game.specialEdition = :specialEdition
		</cfif>
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			AND	console.consoleID = :consoleID
		</cfif>
		<cfif structKeyExists(arguments, "orderby") and len(arguments.orderBy)>
			ORDER BY #arguments.orderby#
		</cfif>
		</cfoutput>
		</cfsavecontent>
		<cfset tQuery = variables.transfer.createQuery(qList) />
		<cfif structKeyExists(arguments,"gameID") and len(arguments.gameID)>
			<cfset tQuery.setParam("gameID",arguments.gameID) />
		</cfif>
		<cfif structKeyExists(arguments,"gameName") and len(arguments.gameName)>
			<cfset tQuery.setParam("gameName",arguments.gameName) />
		</cfif>
		<cfif structKeyExists(arguments,"specialEdition") and len(arguments.specialEdition)>
			<cfset tQuery.setParam("specialEdition",arguments.specialEdition) />
		</cfif>
		<cfif structKeyExists(arguments,"consoleID") and len(arguments.consoleID)>
			<cfset tQuery.setParam("consoleID",arguments.consoleID) />
		</cfif>
		
		<cfreturn variables.transfer.listByQuery(tQuery) />
	</cffunction>
	<cffunction name="getByAttributes" access="public" output="false" returntype="array">
		<cfargument name="gameID" type="uuid" required="false" />
		<cfargument name="consoleID" type="uuid" required="false" />
		<cfargument name="gameName" type="String" required="false" />
		<cfargument name="specialEdition" type="Boolean" required="false" />
		<cfargument name="orderby" type="string" required="false" />
		
		<cfset var qList = getByAttributesQuery(argumentCollection=arguments) />		
		<cfset var arrObjects = arrayNew(1) />
		<cfset var tmpObj = "" />
		<cfset var i = 0 />
		<cfloop from="1" to="#qList.recordCount#" index="i">
			<cfset tmpObj = variables.transfer.get("console.game",qList.gameID[i]) />
			<cfset arrayAppend(arrObjects,tmpObj) />
		</cfloop>
		
		<cfreturn arrObjects />
	</cffunction>
</cfcomponent>
